from app.utils.system import clear_console

from app.labs.lab1 import lab1
# from app.labs.lab2 import lab2
from app.labs.lab3 import lab3
# from app.labs.lab4 import lab4
# from app.labs.lab5 import lab5
# from app.labs.lab6 import lab6
# from app.labs.lab7 import lab7
from app.labs.labTest import labTest

class menu:
    
    def __init__(self):
        pass  # Конструктор пока пустой, при необходимости можно добавить параметры

    def main_menu(self):
        clear_console()
        while True:
            print('\nMain Menu:')
            print('1. Задача 1')
            print('2. Задача 2 (Не работает)')
            print('3. Задача 3')
            print('4. Задача 4 (Не работает)')
            print('5. Задача 5 (Не работает)')
            print('6. Задача 6 (Не работает)')
            print('7. Задача 7 (Не работает)')
            print('8. Задача Test')
            print('0. Exit')

            choice = input('Select an option: ')

            clear_console()
            if choice == '1':
                self.lab1_menu()
            # elif choice == '2':
            #     self.lab2_menu()  # Переход к подменю Задачи 2
            elif choice == '3':
                self.lab3_menu()
            # elif choice == '4':
            #     self.lab4_menu()  # Добавлен вызов меню задачи 4
            elif choice == '8':
                self.labTest_menu()  # Добавлен вызов меню задачи 5
            elif choice == '0':
                print('Exiting program...')
                break
            else:
                print('Invalid option')

    def lab1_menu(self):
        """Меню для lab 1 с подкатегориями."""
        clear_console()
        while True:
            print('\nЛаб 1:')
            print('1. Генерация одномерных данных. Статистические характеристики')
            print('0. Назад')

            choice = input('Выберите подкатегорию: ')

            clear_console()
            l1 = lab1()  # создаем объект для задачи 1

            if choice == '1':
                l1.main()  # Выполнить первую подзадачу
            elif choice == '0':
                break  # Вернуться в основное меню
            else:
                print('Неверный выбор, попробуйте снова.')

    def lab2_menu(self):
        pass

    def lab3_menu(self):
        """Меню для lab 3 с подкатегориями."""
        clear_console()
        while True:
            print('\nЛаб 3:')
            print('1. Набор данных «Ирисы Фишера»»')
            print('0. Назад')

            choice = input('Выберите подкатегорию: ')

            clear_console()
            l3 = lab3()  # создаем объект для задачи 1

            if choice == '1':
                l3.main()  # Выполнить первую подзадачу
            elif choice == '0':
                break  # Вернуться в основное меню
            else:
                print('Неверный выбор, попробуйте снова.')

    def labTest_menu(self):
        """Меню для lab Тест"""
        clear_console()
        lT = labTest()
        
        while True:
            print('\nЛаб Тест:')
            print('1. Рассчитать значение дискриминанта и по результату выдать в консоль сообщение, сколько вещественных корней имеет уравнение.')
            print('0. Назад')

            choice = input('Выберите подкатегорию: ')

            clear_console()

            if choice == '1':

                lT.start()
            elif choice == '0':
                break
            else:
                print('Неверный выбор, попробуйте снова.')
